#!/usr/bin/env python
#Modified the file issued by pparreira 
#http://www.instructables.com/id/MyPIAmp-project-RPI-player-and-amplifier/?ALLSTEPS
import telnetlib;
import time;
import os;
import subprocess;
import lirc;


#
# function BarGraph
#
# display a custom bar graph in a 16 chars long
#
#
def BarGraph(Percent, type):                  # string passed in format xxx%; type = 0 Full 16 chars lenght [bbbbbbbbbbbbbbb]; type = 1; format = 999%[bbbbbbbbbb]
        RSTR = ""                               # Return variable
        num =0                                          # counter for for next loop
        Percval=0                                       # Variable to hold integer of percentage
        PercStr = ""                            # Variable to hold Percentage String
        if type == 1:
		StartBracket = "%["                     # Symbol starting Graph
        	EndBracket = "]"                        # Symbol terminating graph
        	Step = 10                                       # jumping Percentage values as 10 blocks to display 100%
	else:
		StartBracket = "["
		EndBracket = "]"
		Step = int(100/14)
	
        PercStr = Percent.strip()                    # remove all spaces from argument
        PercStr = Percent.strip('()%')       	# remove all marked chars
        PercVal = int(PercStr)

	if type == 1:
	        # add spaces depending on len of number...
        	if PercVal < 10:
                	PercStr = " " + PercStr + StartBracket
        	elif PercVal <100:
                	PercStr =  PercStr + StartBracket
        	else:
                	PercStr = PercStr + StartBracket

	else:
		PercStr = StartBracket

        # build the  bargraph   047%[####______]
	for num in range(0,100,Step+1):
		if num+Step <= PercVal:
			RSTR += chr(219)
		else:
			RSTR += "_"
		
       
	Percent = PercStr + RSTR + EndBracket
        return Percent







host='127.0.0.1';
port='13666';
data = ""

click = 0


tn = telnetlib.Telnet(host, port)
tn.write("hello\r");

data += tn.read_until("\n");
tn.write("screen_add my_screen\n");
data += tn.read_until("\n");

tn.write("screen_set my_screen 1 -heartbeat off\n");
data += tn.read_until("\n");

tn.write("widget_add my_screen 1 scroller\n");
data += tn.read_until("\n");

tn.write("widget_add my_screen 2 scroller\n");
data += tn.read_until("\n");

isnet = 0		# Tem rede ? 1=sim
xfade = 0
screenid = 0
select = 0
var = 1;
spacer = "                "  # 16 spaces
mpc_start = 0
PLAYLIST_MSG = []
NUM_STATIONS = 0
STATION = 0

togglescr0 = 0


while var == 1 :
  sockid = lirc.init("irexec", blocking = False)   #???  
  codeIR = lirc.nextcode()		# get IR command
  if codeIR:
	if codeIR[0] =='mpc volume +1':
		click += 1
	elif codeIR[0] =='mpc volume -1':
		click -= 1	 
	elif codeIR[0] =='mpc play':
		select = 1
  screenid = click % 7


  cmd1 = "mpc --format '%artist%' | head -n 1"    #gets the currently playing artist from mpc
  process = subprocess.Popen(cmd1, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  mpc_artist = process.stdout.read().strip()
  mpc_artist 
  if len(mpc_artist) > 16:
    mpc_artist += spacer

  cmd2 = "mpc | grep vol | cut -d% -f1 | sed 's/[^0-9]*//g'"    #gets the volume level from mpc
  process = subprocess.Popen(cmd2, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  mpc_vol = process.stdout.read().strip()

  cmd3 = "mpc | head -2 | tail -1 | awk '{print $1}'" # gets the player state ie paused playing etc
  process = subprocess.Popen(cmd3, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  mpc_state = process.stdout.read().strip()

  cmd4 = "hostname -I"  #gets the current ip of RPI
  process = subprocess.Popen(cmd4, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  ip_addr = process.stdout.read().strip()
  if len(ip_addr)>0:
	isnet=1	
  else:
	isnet=0
	
  cmd5 = "netstat -t | grep rfe" #check if a user is connected via airplay
  process = subprocess.Popen(cmd5, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  airplay = process.stdout.read().strip()

  cmd7 = "mpc --format '%title%' | head -n 1" # nome da musica  
  process = subprocess.Popen(cmd7, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  mpc_song = process.stdout.read().strip()
  if len(mpc_song) > 16:
  	mpc_song += spacer

  cmd8 = "mpc --format '%album%' | head -n 1" # nome do album  
  process = subprocess.Popen(cmd8, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  mpc_album = process.stdout.read().strip()
  if len(mpc_album) > 16:
        mpc_album += spacer
  
  cmd10 = "mpc --format '%name%' | head -n 1" # titulo  
  process = subprocess.Popen(cmd10, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  mpc_name = process.stdout.read().strip()
  if len(mpc_name) > 16:
        mpc_name += spacer

  cmd11 = "mpc | head -n 2 | tail -n 1 | awk {'print $4'}" # % current position (xx%)  
  process = subprocess.Popen(cmd11, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  mpc_pos = process.stdout.read().strip()
  if len(mpc_pos) > 16:
        mpc_pos += spacer

  cmd12 = "mpc | head -n 2 | tail -n 1 | awk {'print $3'}" # % current elapsedtime/time (xx%)  
  process = subprocess.Popen(cmd12, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  mpc_elapsed = process.stdout.read().strip()
  if len(mpc_elapsed) > 16:
        mpc_elapsed += spacer

  cmd13 = "mpc | head -n 2 | tail -n 1 | awk {'print $2'}" # % current position in playlist / total   
  process = subprocess.Popen(cmd13, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  mpc_playlist = process.stdout.read().strip()
  if len(mpc_playlist) > 16:
        mpc_playlist += spacer

  cmd14 = "mpc crossfade | head -n 1 | tail -n 1 | awk {'print $2'}" # % current position in playlist / total   
  process = subprocess.Popen(cmd14, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  mpc_crossfade = process.stdout.read().strip()
  if len(mpc_crossfade) > 16:
        mpc_crossfade += spacer 
  xfade = int(mpc_crossfade)	

  cmd15 = "mpc | head -n 3 | tail -n 1 | awk {'print $6'}" # % current random setting   
  process = subprocess.Popen(cmd15, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  mpc_random = process.stdout.read().strip()
  if len(mpc_random) > 16:
        mpc_random += spacer 


  cmd16 = "mpc --format '%file%' | head -n 1"    #gets the path of current song  from mpc
  process = subprocess.Popen(cmd16, stdout=subprocess.PIPE , shell=True)
  os.waitpid(process.pid, 0)[1]
  mpc_file = process.stdout.read().strip()
  mpc_file
  if len(mpc_file) >= 16:
    mpc_file += spacer

  
  

  if mpc_state != "[playing]":  ##If airplay is in use, pause MPC and display Airplay Mode on LCD else display mpc data as normal
    tn.write("widget_set my_screen 1 1 1 16 1 m 4 \"   PI - HIFI  \"\n");
    data += tn.read_until("\n");
    if airplay: 	# someone is connected via airplay
    	tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"Airplay: %s \"\n" % ("On"));
    	data += tn.read_until("\n");
    else:
	if mpc_state =="[paused]":
		tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"    PAUSE     \"\n");
        	data += tn.read_until("\n");
	else:
		tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"Playlist:%s Status:%s IP:%s \"\n" % (mpc_playlist,mpc_state,ip_addr));
    		data += tn.read_until("\n");	
	
    # check if Playlist is not empty and if it is, load the default one...
    if mpc_playlist == 'n/a' and mpc_start == 0:
	tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"Loading...\"\n");
        data += tn.read_until("\n");
        CS4 = "mpc clear" # clear playlist   
        process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
        os.waitpid(process.pid, 0)[1]
        CS4 = "mpc ls USB/Music | mpc add" # add default playlist from USB disk   
        process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
        os.waitpid(process.pid, 0)[1]
	CS4 = "mpc random on" # start playing   
        process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
        os.waitpid(process.pid, 0)[1]
 	tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"Playlist:%s Status:%s IP:%s \"\n" % (mpc_playlist,mpc_state,ip_addr));
        data += tn.read_until("\n");
	mpc_start = 1
	NUM_STATIONS=0
  else:
    mpc_start = 1	# flag that says mpc started at least once playing: good signal :-)
    # screen 0	 	
    if screenid == 0:
	if len(mpc_artist)==0:
		tn.write("widget_set my_screen 1 1 1 16 1 m 4 \"%s \" \n" % (mpc_name));                                                               
	        data += tn.read_until("\n");
	else:
        	tn.write("widget_set my_screen 1 1 1 16 1 m 4 \"%s \" \n" % (mpc_artist));
    		data += tn.read_until("\n");
	if select==1:
		togglescr0 += 1 
		togglescr0 = togglescr0 % 2
		select = 0
	if togglescr0 == 1:
		tn.write("widget_set my_screen 2 1 2 16 2 m 2 \"%s \" \n" % (mpc_album));
        	data += tn.read_until("\n");	
		select = 0
	if togglescr0 == 0:
                tn.write("widget_set my_screen 2 1 2 16 2 m 2 \"%s \" \n" % (mpc_song));
                data += tn.read_until("\n");

    # screen 1
    if screenid == 1:
	tn.write("widget_set my_screen 1 1 1 16 1 m 4 \"%s \" \n" % (mpc_file));
        data += tn.read_until("\n");

	if select==1:
                togglescr0 += 1
                togglescr0 = togglescr0 % 2
                select = 0
        if togglescr0 == 1:
                tn.write("widget_set my_screen 2 1 2 16 2 m 2 \"#%s##  \" \n" % (mpc_playlist));
                data += tn.read_until("\n");
                select = 0
        if togglescr0 == 0:
		if len(mpc_name)==0:
			mpc_name="No info..."
                tn.write("widget_set my_screen 2 1 2 16 2 m 2 \"%s \" \n" % (mpc_name));
                data += tn.read_until("\n");

    # Screen 2
    if screenid == 2:
	tn.write("widget_set my_screen 1 1 1 16 1 m 4 \"%s \" \n" % (BarGraph(mpc_pos, 0)));
        data += tn.read_until("\n");
	tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"%s %s\"\n" % (mpc_elapsed,mpc_pos));        
        data += tn.read_until("\n");
    # Screen 3
    if screenid == 3:
	PLAYLIST_MSG = []
	NUM_STATIONS = 0
        tn.write("widget_set my_screen 1 1 1 16 1 m 4 \"WEB Radio\" \n");
        data += tn.read_until("\n");
        tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"Load Playlist  Y\"\n");
        data += tn.read_until("\n");
	if select==1:
		tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"Loading...\"\n");
                data += tn.read_until("\n");
		PLAYLIST_MSG = []
        	NUM_STATIONS = 0
		CS4 = "mpc stop" # stop playing   
                process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
                os.waitpid(process.pid, 0)[1]
		CS4 = "mpc clear" # clear playlist   
                process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
                os.waitpid(process.pid, 0)[1]

		# Run shell script to add all stations  
   		# to the MPC/MPD music player playlist
		CS4 = "mpc load radios"
		process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
                os.waitpid(process.pid, 0)[1]  
   		# output = run_cmd("~/mypiampradiolist.sh")  
     		# Load PLAYLIST_MSG list  ~/mypiampradiolist.sh
  
		process = subprocess.Popen(cmd13, stdout=subprocess.PIPE , shell=True)
  		os.waitpid(process.pid, 0)[1]
  		mpc_playlist = process.stdout.read().strip()
   		NUM_STATIONS = mpc_playlist   
   		# Load PLAYLIST_MSG list  ~/mypiampradiolist.sh
  
		tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"Loaded %s Stations\"\n" % (NUM_STATIONS));
                data += tn.read_until("\n");
		
		CS4 = "mpc random off" # start playing   
                process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
                os.waitpid(process.pid, 0)[1]

                CS4 = "mpc play" # start playing   
                process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
                os.waitpid(process.pid, 0)[1]
                select = 0
		time.sleep(3)
    # Screen 4
    if screenid == 4:
        tn.write("widget_set my_screen 1 1 1 16 1 m 4 \"USB Playlist\" \n");
        data += tn.read_until("\n");
        tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"Load Playlist  Y\"\n");
        data += tn.read_until("\n");
	if select == 1:
		tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"Loading...\"\n");
        	data += tn.read_until("\n");

		CS4 = "mpc stop" # stop playing   
                process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
                os.waitpid(process.pid, 0)[1]

		CS4 = "mpc clear" # clear playlist   
  		process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
  		os.waitpid(process.pid, 0)[1]

		CS4 = "mpc ls USB/Music | mpc add" # add default playlist from USB disk   
                process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
                os.waitpid(process.pid, 0)[1]

		CS4 = "mpc random on" # start playing   
                process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
                os.waitpid(process.pid, 0)[1]

		CS4 = "mpc play" # start playing   
                process = subprocess.Popen(CS4, stdout=subprocess.PIPE , shell=True)
                os.waitpid(process.pid, 0)[1]                
		select = 0
    # Screen 5
    if screenid == 5:
        tn.write("widget_set my_screen 1 1 1 16 1 m 4 \"Random play\" \n");
        data += tn.read_until("\n");
        tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"%s \"\n" % mpc_random);
        data += tn.read_until("\n");
	if select ==1:
		if mpc_random == "on":
			CS5 = "mpc random off"  #set random off
  			process = subprocess.Popen(CS5, stdout=subprocess.PIPE , shell=True)
  			os.waitpid(process.pid, 0)[1]
		else:
			CS5 = "mpc random on"  #set random on
                        process = subprocess.Popen(CS5, stdout=subprocess.PIPE , shell=True)
                        os.waitpid(process.pid, 0)[1]
		select = 0
    # Screen 6
    if screenid == 6:
        tn.write("widget_set my_screen 1 1 1 16 1 m 4 \"Crossfade\" \n");
        data += tn.read_until("\n");
        tn.write("widget_set my_screen 2 1 2 16 2 m 4 \"%s \" \n" % (mpc_crossfade));
        data += tn.read_until("\n");
	if select == 1:
		xfade = (xfade + 5) % 25
		CS6 = "mpc crossfade " + str(xfade)  # set crossfade   
                process = subprocess.Popen(CS6, stdout=subprocess.PIPE , shell=True)
                os.waitpid(process.pid, 0)[1]
		select = 0

	
 
time.sleep(0.4)
lirc.deinit()



